Subject: Re: bug#18266: Bug#758105: bug#18266: grep -P and invalid exits with error

From: Jim Meyering <[email-masked]>
Date: Thu, 11 Sep 2014 11:37:11 -0700

On Thu, Sep 11, 2014 at 10:07 AM, Paul Eggert <[email-masked]> wrote:
> Vincent Lefevre wrote:
>
>> I've just reported a new Debian concerning the performance problem.
>
>
> It's not clear from http://bugs.debian.org/761157 that the performance
> problem occurs only with -P, but I assume that's what is meant.
>
> Since this is a performance bug with PCRE, I suggest moving the Debian bug
> report to the Debian libpcre3 package.  Grep cannot go back to the old way,
> which could cause grep to crash, and the bug cannot be fixed in grep because
> libpcre3 does not provide a fast way to search arbitrary data that may
> include encoding errors.  It really is a problem that requires changes to
> libpcre3 to fix; grep cannot fix it.
>
> In the meantime, in order to use 'grep' to search for strings in arbitrary
> data, I suggest omitting the '-P'.  Also, I suggest using the C locale.
>
> As the GNU bug 18266 "grep -P and invalid exits with error" has been fixed,
> I'm closing that bug report.  Please feel free to open a separate GNU bug
> report for the performance issue.
>
> PS.  While composing this email I noticed another bug in grep -P and
> encoding errors, which I fixed by installing the attached patch.

Thanks for fixing yet another bug, Paul.
Would you mind adding a test to trigger that one?